package sklep.security;

import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.HttpMethod;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.config.annotation.ObjectPostProcessor;
import org.springframework.security.config.annotation.authentication.configuration.AuthenticationConfiguration;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.web.SecurityFilterChain;

@Configuration
public class SecurityConfig {
	
	@Bean
	SecurityFilterChain setHttpSecurity(HttpSecurity httpSecurity) throws Exception {
		httpSecurity.authorizeHttpRequests()
			// .antMatchers(HttpMethod.POST).authenticated()
			.antMatchers("/", "/whoami", "/*.css").permitAll()
			.antMatchers("/hello", "/time").permitAll()
			.antMatchers("/alt?/**").authenticated() // zalogowany jako ktokolwiek
			.antMatchers("/products/new", "/products/*/edit").hasAuthority("ROLE_manager")
			.antMatchers("/products/**").permitAll()
			.antMatchers("/customers/new", "/customers/*/edit").hasAuthority("ROLE_manager")
			.antMatchers("/customers/**").authenticated()
			.anyRequest().denyAll()
		.and()
			.formLogin()
		;
		return httpSecurity.build();
	}
	
	@Bean
	AuthenticationManager authenticationManager(AuthenticationConfiguration authenticationConfiguration, ApplicationContext applicationContext) throws Exception {
        ObjectPostProcessor<Object> objectPostProcessor = new ObjectPostProcessor<Object>() {
			public <O> O postProcess(O object) {
				return object;
			}
		};
		
		return authenticationConfiguration.authenticationManagerBuilder(objectPostProcessor, applicationContext)
			.inMemoryAuthentication()
				.withUser("ala").password("{noop}abc123").roles("manager", "worker").and()
				.withUser("ola").password("{noop}abc123").roles("worker").and()
			.and()
			.build();
		
	}

}
